#include <windows.h>

class CPrecisionTimer  
{
public:
	double Stop() {
		LARGE_INTEGER curval;
		QueryPerformanceCounter(&curval);
		long double f = ToDouble(m_start);
		long double f1 = ToDouble(curval);
		long double f3 = ToDouble(m_freq);
		return (f1 - f)/f3;
	}
	long double ToDouble(LARGE_INTEGER& val) {
		long double f = val.u.HighPart;
		f = f * (DWORD)-1;//4294967296;
		f += val.u.LowPart;
		return f;
	}
	void Start() {
		QueryPerformanceCounter(&m_start);
	}
	CPrecisionTimer() {
		QueryPerformanceFrequency(&m_freq);
	}
private:
	LARGE_INTEGER m_start;
	LARGE_INTEGER m_freq;
};
